package feie

import (
	"fmt"
	"strings"
	"time"

	"git.rosy.net.cn/jx-callback/business/model/dao"

	"git.rosy.net.cn/baseapi/platformapi/feieapi"
	"git.rosy.net.cn/baseapi/utils"
	"git.rosy.net.cn/jx-callback/business/jxutils"
	"git.rosy.net.cn/jx-callback/business/jxutils/jxcontext"
	"git.rosy.net.cn/jx-callback/business/model"
	"git.rosy.net.cn/jx-callback/business/partner"
	"git.rosy.net.cn/jx-callback/globals"
	"git.rosy.net.cn/jx-callback/globals/api"
)

var (
	CurPrinterHandler *PrinterHandler
)

type PrinterHandler struct {
}

func init() {
	CurPrinterHandler = new(PrinterHandler)
	partner.RegisterPrinterPlatform(CurPrinterHandler)
}

func (c *PrinterHandler) getOrderContent(order *model.GoodsOrder, storeTel string, storeDetail *dao.StoreDetail) (content string) {
	expectedDeliveryTime := order.ExpectedDeliveredTime
	if utils.IsTimeZero(expectedDeliveryTime) {
		expectedDeliveryTime = order.OrderCreatedAt.Add(1 * time.Hour)
	}
	orderParams := []interface{}{}
	getCode := ""
	if order.VendorID == model.VendorIDEBAI {
		getCode = fmt.Sprintf("<B>饿百取货码:%s</B><BR><BR>\n", jxutils.GetEbaiOrderGetCode(order))
	}
	orderFmt := ``
	if storeDetail != nil {
		if storeDetail.BrandIsPrint == model.NO {
			orderFmt += `
		<CB>%s</CB><BR><BR>
		`
			if order.VendorOrgCode == "34665" {
				orderParams = append(orderParams, globals.StoreNameEbai2)
			} else {
				orderParams = append(orderParams, storeDetail.BrandName)
			}
		}
	}
	orderFmt += `
<C>手机买菜上京西</C><BR>
<C>极速到家送惊喜</C><BR>
--------------------------------<BR>
下单时间: %s<BR>
预计送达: %s<BR>
订单编号: %s<BR>
`
	if order.BusinessType == model.BusinessTypeDingshida {
		orderFmt += `
<B>预订单</B><BR>
`
	}
	orderFmt += `
<BR>

<B>%s#%d</B><BR><BR>
<QR>%s</QR><BR>
` + getCode +
		`客户: %s<BR>
电话: %s<BR>
地址: %s<BR>
<BR>
客户备注: <BR>
<B>%s</B><BR>
<BR>

<BR>
商品明细: <BR>
品名    数量    单价       小计<BR>
--------------------------------<BR>`
		// <BOLD>实际支付:</BOLD>%s<BR>
	orderParams = append(orderParams,
		utils.Time2Str(order.OrderCreatedAt),
		utils.Time2Str(expectedDeliveryTime),
		order.VendorOrderID,
		jxutils.GetVendorName(order.VendorID),
		order.OrderSeq,
		order.VendorOrderID,
		order.ConsigneeName,
		order.ConsigneeMobile,
		order.ConsigneeAddress,
		order.BuyerComment,
		// jxutils.IntPrice2StandardCurrencyString(order.ActualPayPrice),
	)

	for _, sku := range order.Skus {
		orderFmt += `%s<BR>`
		orderFmt += `%8s%10s%10s<BR>`
		orderParams = append(orderParams, sku.SkuName, "x"+utils.Int2Str(sku.Count), jxutils.IntPrice2StandardCurrencyString(sku.SalePrice), jxutils.IntPrice2StandardCurrencyString(sku.SalePrice*int64(sku.Count)))
		//标品需要打印条形码
		if sku.Upc != "" {
			orderFmt += `upc码： %s<BR>`
			orderParams = append(orderParams, sku.Upc)
		}
	}
	orderFmt += `<BR>
<BOLD>共%d种%d件商品</BOLD>
<BR>
--------------------------------<BR>
<C><L><BOLD>商品质量问题请联系:</BOLD></L><BR></C>
<C><L><BOLD>%s:%s</BOLD></L><BR></C><BR>
<BR>
更多信息请关注官方微信: %s<BR>
<BR>
<BR><BR>
--------------------------------<BR>
--------------------------------<BR>
<BR><BR>
`
	// <QR>http://weixin.qq.com/r/tkkDGzTERmk5rXB49xyk</QR>
	orderParams = append(orderParams, order.SkuCount, order.GoodsCount, order.StoreName, storeTel, globals.StoreName)
	return fmt.Sprintf(strings.Replace(orderFmt, "\n", "", -1), orderParams...)
}

func (c *PrinterHandler) getOrderContentBig(order *model.GoodsOrder, storeTel string, storeDetail *dao.StoreDetail) (content string) {
	expectedDeliveryTime := order.ExpectedDeliveredTime
	if utils.IsTimeZero(expectedDeliveryTime) {
		expectedDeliveryTime = order.OrderCreatedAt.Add(1 * time.Hour)
	}
	getCode := ""
	if order.VendorID == model.VendorIDEBAI {
		getCode = fmt.Sprintf("<B>饿百取货码:%s</B><BR><BR>\n", jxutils.GetEbaiOrderGetCode(order))
	}
	orderParams := []interface{}{}
	orderFmt := ``
	if storeDetail != nil {
		if storeDetail.BrandIsPrint == model.NO {
			orderFmt += `
		<CB>%s</CB><BR><BR>
		`
			if order.VendorOrgCode == "34665" {
				orderParams = append(orderParams, globals.StoreNameEbai2)
			} else {
				orderParams = append(orderParams, storeDetail.BrandName)
			}
		}
	}
	orderFmt += `
<C>手机买菜上京西</C><BR>
<C>极速到家送惊喜</C><BR>
--------------------------------<BR>
<B>下单时间: %s<BR><BR><BR></B>
<B>预计送达: %s<BR><BR><BR></B>
<B>订单编号: %s<BR></B>
<BR>

<B>%s#%d</B><BR><BR>
<QR>%s</QR><BR>
` + getCode +
		`<B>客户: %s<BR></B>
<B>电话: %s<BR></B>
<B>地址: %s<BR></B>
<BR>
<B>客户备注: <BR></B>
<B>%s</B><BR>
<BR>

<BR>
<B>商品明细: <BR></B>
<B>品名数量单价小计<BR></B>
--------------------------------<BR>`
		// <B><BOLD>实际支付:</BOLD></B><B>%s<BR></B>
	orderParams = append(orderParams,
		utils.Time2Str(order.OrderCreatedAt),
		utils.Time2Str(expectedDeliveryTime),
		order.VendorOrderID,
		jxutils.GetVendorName(order.VendorID),
		order.OrderSeq,
		order.VendorOrderID,
		order.ConsigneeName,
		order.ConsigneeMobile,
		order.ConsigneeAddress,
		order.BuyerComment,
		// jxutils.IntPrice2StandardCurrencyString(order.ActualPayPrice),
	)

	for _, sku := range order.Skus {
		orderFmt += `<B>%s<BR></B>`
		orderFmt += `<B>%s %s %s<BR><BR></B>`
		orderParams = append(orderParams, sku.SkuName, "x"+utils.Int2Str(sku.Count), jxutils.IntPrice2StandardCurrencyString(sku.SalePrice), jxutils.IntPrice2StandardCurrencyString(sku.SalePrice*int64(sku.Count)))
		//标品需要打印条形码
		if sku.Upc != "" {
			orderFmt += `upc码： %s<BR>`
			orderParams = append(orderParams, sku.Upc)
		}
	}
	orderFmt += `<BR>
<B><BOLD>共%d种%d件商品</BOLD></B>
<BR>
--------------------------------<BR>
<C><L><BOLD>商品质量问题请联系:</BOLD></L><BR></C>
<C><L><BOLD>%s:%s</BOLD></L><BR></C><BR>
<BR>
<B>更多信息请关注官方微信: %s<BR></B>
<BR>
<BR><BR>
--------------------------------<BR>
--------------------------------<BR>
<BR><BR>
`
	// <QR>http://weixin.qq.com/r/tkkDGzTERmk5rXB49xyk</QR>
	orderParams = append(orderParams, order.SkuCount, order.GoodsCount, order.StoreName, storeTel, globals.StoreName)
	return fmt.Sprintf(strings.Replace(orderFmt, "\n", "", -1), orderParams...)
}

func (c *PrinterHandler) GetVendorID() int {
	return model.VendorIDFeiE
}

func (c *PrinterHandler) PrintMsg(ctx *jxcontext.Context, id1, id2, msgTitle, msgContent string) (printerStatus *partner.PrinterStatus, err error) {
	globals.SugarLogger.Debugf("PrintMsg id1:%s", id1)
	if id1 != "" {
		if globals.EnableStoreWrite {
			_, err = api.FeieAPI.PrintMsg(id1, msgContent, 1)
		}
		if err == nil {
			printerStatus, err = c.GetPrinterStatus(ctx, id1, id2)
		}
	} else {
		printerStatus = &partner.PrinterStatus{
			PrintResult: partner.PrintResultNoPrinter,
		}
	}
	return printerStatus, err
}

func (c *PrinterHandler) GetPrinterStatus(ctx *jxcontext.Context, printerSN, printerKey string) (printerStatus *partner.PrinterStatus, err error) {
	tmpStatus, err := api.FeieAPI.QueryPrinterStatus(printerSN)
	if err == nil {
		printerStatus = &partner.PrinterStatus{
			PrinterStatus: tmpStatus,
			PrintResult:   partner.PrintResultSuccess,
		}
		printerStatus.Printed, printerStatus.Waiting, err = api.FeieAPI.QueryOrderInfoByDate(printerSN, time.Now())
	}
	return printerStatus, err
}

func (c *PrinterHandler) PrintOrder(ctx *jxcontext.Context, store *model.Store, storeDetail *dao.StoreDetail, order *model.GoodsOrder) (printerStatus *partner.PrinterStatus, err error) {
	globals.SugarLogger.Debugf("feie PrintOrderByOrder orderID:%s, storeID:%d", order.VendorOrderID, store.ID)
	if len(order.Skus) == 0 {
		return
	}
	content := ""
	if store.PrinterFontSize == partner.PrinterFontSizeBig {
		content = c.getOrderContentBig(order, store.Tel1, storeDetail)
	} else {
		content = c.getOrderContent(order, store.Tel1, storeDetail)
	}
	return c.PrintMsg(ctx, store.PrinterSN, store.PrinterKey, order.VendorOrderID, content)
}

func (c *PrinterHandler) RegisterPrinter(ctx *jxcontext.Context, printerSN, printerKey, printerName string) (notUsed1, notUsed2 string, err error) {
	var no map[string]string
	if globals.EnableStoreWrite {
		_, no, err = api.FeieAPI.PrinterAddList([]*feieapi.PrinterInfo{
			&feieapi.PrinterInfo{
				SN:   printerSN,
				Key:  printerKey,
				Name: printerName,
			},
		})
	} else {
		no = make(map[string]string)
	}
	if err == nil {
		if no[printerSN] != "" {
			if no[printerSN] == feieapi.ErrMsgAlredyAdded {
				api.FeieAPI.PrinterEdit(printerSN, printerName, "")
			} else {
				err = fmt.Errorf("添加打印机出错:%s", no[printerSN])
			}
		}
	}
	return "", "", err
}

func (c *PrinterHandler) UnregisterPrinter(ctx *jxcontext.Context, printerSN, notUsed string) (err error) {
	if globals.EnableStoreWrite {
		_, _, err = api.FeieAPI.PrinterDelList([]string{printerSN})
	}
	return err
}

func (c *PrinterHandler) BindPrinter(ctx *jxcontext.Context, mapData map[string]interface{}) (bindResult *partner.BindPrinterResult, err error) {
	return nil, fmt.Errorf("%s打印机当前不支持扫码绑定", model.VendorChineseNames[model.VendorIDFeiE])
}

func (c *PrinterHandler) RebindPrinter(ctx *jxcontext.Context, lastBindResult *partner.BindPrinterResult) (bindResult *partner.BindPrinterResult, err error) {
	return nil, fmt.Errorf("%s打印机当前不支持扫码绑定", model.VendorChineseNames[model.VendorIDFeiE])
}

func (c *PrinterHandler) EmptyPrintList(ctx *jxcontext.Context, id1, id2 string) (err error) {
	if globals.EnableStoreWrite {
		err = api.FeieAPI.DelPrinterSqs(id1)
	}
	return err
}

func (c *PrinterHandler) PlayText(ctx *jxcontext.Context, id1, id2, orderID, text string) (printerStatus *partner.PrinterStatus, err error) {
	return c.GetPrinterStatus(ctx, id1, id2)
}

func (c *PrinterHandler) SetSound(ctx *jxcontext.Context, id1, id2, sound string) (err error) {
	if globals.EnableStoreWrite {
		err = api.FeieAPI.SetSound(id1, sound)
	}
	return err
}
